include 'ZeroPage.inc'
include 'Vram.inc'

OffByte equ ScreenMode
OnByte equ OffByte or 2

tempo equ 150/4
tempo_denom equ 500/4

zseg
pScore:
    defw 0
dseg
toneLen:
    defb 0
time: 
    defb 0
currentTone:
    defb 0
delta:
    defb 0
lastTone:
    defb 0


cseg
InitSound_: public InitSound_
    lda #0
    sta <pScore
    sta <pScore+1
    sta time
    sta currentTone
rts


SoundHandler: public SoundHandler
    pha
    txa | pha
    tya | pha
        lda currentTone
        if ne
            cmp lastTone
            if ne
                sta $fe06
                clc|adc delta
                sta currentTone
            else
                lda #0 | sta currentTone
                lda #OffByte | sta $fe07
            endif
            jmp exit
        endif
        lda <pScore | ora <pScore+1
        if ne
            lda time
            sec | sbc #tempo
            sta time
            if cc
                dec toneLen
                if eq
                    ldy #0 | lda (<pScore),y
                    if eq
                        ; end
                        lda #OffByte | sta $fe07
                        lda #0
                        sta <pScore
                        sta <pScore+1
                        jmp exit
                    endif
                    sta toneLen
                    iny | lda (<pScore),y
                    if ne
                        tax | dex
                        lda cycles,x | sta $fe06
                        lda #OnByte | sta $fe07
                    else
                        lda #OffByte | sta $fe07
                    endif
                    lda <pScore | clc|adc #2 | sta <pScore
                    lda <pScore+1 | adc #0 | sta <pScore+1
                endif
                lda time
                clc | adc #tempo_denom
                sta time
            endif
        endif
        exit:
    pla | tay
    pla | tax
    pla
rts


Melody:
    pha
        sei
            stx <pScore
            sty <pScore+1
            lda #1
            sta toneLen
        cli
    pla
rts


MelodyWait:
    jsr Melody
    pha
        do
            lda <pScore | ora <pScore+1
        while ne | wend
    pla
rts


; void Sound_Fire();
Sound_Fire_: public Sound_Fire_
    pha
        lda currentTone
        if eq
            sei
                lda #10 | sta currentTone | sta $fe06
                lda #2 | sta delta
                lda #90 | sta lastTone
                lda #OnByte | sta $fe07
            cli
        endif
    pla
rts


; void Sound_Hit();
Sound_Hit_: public Sound_Hit_
    pha
        sei
            lda #200 | sta currentTone | sta $fe06
            lda #-4 | sta delta
            lda #100 | sta lastTone
            lda #OnByte | sta $fe07
        cli
    pla
rts


; void Sound_Loose();
Sound_Loose_: public Sound_Loose_
    pha
        sei
            lda #100 | sta currentTone | sta $fe06
            lda #2 | sta delta
            lda #200 | sta lastTone
            lda #OnByte | sta $fe07
        cli
    pla
rts


; void Sound_Up();
up_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Up_: public Sound_Up_
    ldx #low up_notes
    ldy #high up_notes
jmp Melody


; void Sound_Start();
start_notes:
	defb 11,G4,1,0, 5,G4,1,0, 5,C5,1,0
	defb 5,E5,1,0, 11,D5,1,0, 5,C5,1,0
	defb 8,D5,1,0, 2,D5,1,0, 5,D5,1,0, 5,E5,1,0
	defb 11,D5,1,0, 12,0
    defb 0
Sound_Start_: public Sound_Start_
    ldx #low start_notes
    ldy #high start_notes
jmp MelodyWait


; void Sound_GameOver();
over_notes: 
	defb 5,F5,1,0, 5,F5,1,0, 5,E5,1,0, 5,E5,1,0
	defb 5,D5,1,0, 5,D5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,B4,1,0, 5,G4,1,0, 5,A4,1,0, 5,B4,1,0
	defb 23,C5,1,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    ldx #low over_notes
    ldy #high over_notes
jmp MelodyWait


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18

N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2
N16 equ N8/2

cycles:
defb 238 ; C4
defb 225 ; C4S
defb 212 ; D4
defb 200 ; D4S
defb 189 ; E4
defb 178 ; F4
defb 168 ; F4S
defb 159 ; G4
defb 150 ; G4S
defb 141 ; A4
defb 134 ; A4S
defb 126 ; B4
defb 119 ; C5
defb 112 ; C5S
defb 106 ; D5
defb 100 ; D5S
defb 94 ; E5
defb 89 ; F5
