include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"


GroundWidth equ VVramWidth+2
GroundBitsWidth equ 9
ext GroundBits_

dseg
VVram_: public VVram_
    defs VVramWidth*VVramHeight


pVVram equ ZW0
yCount equ ZB0
xCount equ ZB1
bits equ ZB2
leftBute equ ZB1
rightByte equ ZB2


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public	VVramPtr_@Param0
VVramPtr_.x_:	defs 1
VVramPtr_@Param1: public	VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	pha
        lda	VVramPtr_.y_
        asl a | asl a | asl a  ;*8
        sta <pVVram | lda #0 | sta <pVVram+1
        asl <pVVram | rol <pVVram+1 ;16
        asl <pVVram | rol <pVVram+1 ;32
        lda VVramPtr_.x_ | clc | adc <pVVram | sta <pVVram
        lda <pVVram+1 | adc #0 | sta <pVVram+1
        lda <pVVram | clc|adc #low VVram_ | tay
        lda <pVVram+1 | adc #high VVram_ | tax
	pla
rts


; void GroundToVVram();
cseg
NextRow:
    lda <pVVram | clc|adc #VVramWidth | sta <pVVram
    lda <pVVram+1 | adc #0 | sta <pVVram+1
rts
GroundToVVram_: public GroundToVVram_
    pha
        lda #low VVram_ | sta <pVVram
        lda #high VVram_ | sta <pVVram+1
        lda #10 | sta <yCount
        do
            ldy #0
            lda #Char_Space
            do
                sta (<pVVram),y
                iny
                cpy #VVramWidth
            while ne | wend
            jsr NextRow
            dec yCount
        while ne | wend
        
        ldx #0
        lda #10 | sta <yCount
        do
            ldy #0
            do
                lda GroundBits_,x | inx
                sta <bits
                                                    _deb: public _deb
                lda #4 | sta <xCount
                do
                    lda <bits
                    and #3
                    cmp #3
                    if eq
                        lda #Char_Space
                    else
                        clc|adc #Char_Ground
                    endif
                    sta (<pVVram),y | iny
                    lsr <bits | lsr <bits
                    dec <xCount
                while ne | wend
                cpy #VVramWidth
            while ne | wend
            jsr NextRow
            inx
            dec <yCount
        while ne | wend

        lda #2 | sta <yCount
        do
            ldy #0
            lda #Char_Ground
            do
                sta (<pVVram),y
                iny
                cpy #VVramWidth
            while ne | wend
            jsr NextRow
            dec yCount
        while ne | wend
    pla
rts


; void ShiftGround();
cseg
ShiftGround_: public ShiftGround_
    pha
        lda #10 | sta <yCount
        ldx #GroundBitsWidth
        do
            lda #0 | sta <rightByte
            ldy #GroundBitsWidth
            do
                lda #0 | sta <leftBute
                dex | lda GroundBits_,x
                lsr a | ror <leftBute
                lsr a | ror <leftBute
                ora <rightByte
                sta GroundBits_,x
                lda <leftBute | sta <rightByte
                dey
            while ne | wend
            txa
            clc|adc #GroundBitsWidth*2
            tax
            dec<yCount
        while ne | wend
    pla
rts


; ; void VVramBackToFront()
; cseg
; VVramBackToFront_: public VVramBackToFront_
;     pha
;         lda #low VVramBack_ | sta <pSource
;         lda #high VVramBack_ | sta <pSource+1
;         lda #low VVramFront_ | sta <pDestination
;         lda #high VVramFront_ | sta <pDestination+1
;         lda #VVramHeight | sta <count
;         do
;             ldy #0
;             do
;                 lda (<pSource),y
;                 sta (<pDestination),y
;                 iny
;                 cpy #VVramWidth
;             while ne | wend
;             lda <pSource | clc | adc #low VVramWidth | sta <pSource
;             lda <pSource+1 | adc #high VVramWidth | sta <pSource+1
;             lda <pDestination | clc | adc #low VVramWidth | sta <pDestination
;             lda <pDestination+1 | adc #high VVramWidth | sta <pDestination+1
;             dec <count
;         while ne | wend

;         lda #0
;         ldy #0
;         do
;             sta RowFlags_,y
;             iny
;             cpy #3
;         while ne | wend
;     pla
; rts


; ; void SetRowFlags(byte y, byte b);
; dseg
; SetRowFlags_@Param0: public SetRowFlags_@Param0
;     defb 0
; SetRowFlags_@Param1: public SetRowFlags_@Param1
;     defb 0
; SetRowFlags_low equ ZB0
; SetRowFlags_high equ ZB1
; cseg
; SetRowFlags_: public SetRowFlags_
;     pha
;         lda SetRowFlags_@Param1 | sta <SetRowFlags_low
;         lda #0 | sta <SetRowFlags_high
       
;         lda SetRowFlags_@Param0
;         tay
;         and #7
;         tax
;         do | while ne
;             asl <SetRowFlags_low | rol <SetRowFlags_high
;             dex
;         wend
        
;         tya
;         lsr a | lsr a | lsr a
;         tax
        
;         lda RowFlags_,x
;         ora <SetRowFlags_low
;         sta RowFlags_,x
;         inx
;         lda RowFlags_,x
;         ora <SetRowFlags_high
;         sta RowFlags_,x
;     pla
; rts


; ; void GroundToVVram()
; cseg
; GroundToVVram_: public GroundToVVram_
;     pha
;         lda #low Background_ | sta <pSource
;         lda #high Background_ | sta <pSource+1
;         lda #low VVramBack_ | sta <pDestination
;         lda #high VVramBack_ | sta <pDestination+1
;         lda #VVramHeight | sta <count
;         do
;             ldy #0
;             do
;                 lda (<pSource),y
;                 sta (<pDestination),y
;                 iny
;                 cpy #VVramWidth
;             while ne | wend
;             lda <pSource | clc | adc #low GroundWidth | sta <pSource
;             lda <pSource+1 | adc #high GroundWidth | sta <pSource+1
;             lda <pDestination | clc | adc #low VVramWidth | sta <pDestination
;             lda <pDestination+1 | adc #high VVramWidth | sta <pDestination+1
;             dec <count
;         while ne | wend

;         lda #0
;         ldy #0
;         do
;             sta RowFlags_,y
;             iny
;             cpy #3
;         while ne | wend
;     pla
; rts
