include 'Zeropage.inc'
include 'Vram.inc'
include 'VVram.inc'

ext VVram_
ext Chars_

VramTop equ Vram

pSource equ ZW0
pDestination equ ZW1
pVVram equ ZW2
pBackup equ ZW3
yCount equ ZB0
xOffset equ ZB1
rowFlag equ ZB2
flagOffset equ ZB3
maskBit equ ZB4


dseg
Backup:
    defs VVramWidth*VVramHeight


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #low VramOrg | sta pDestination
        lda #high VramOrg | sta pDestination+1
        lda #0
        ldx #$80-high VramOrg
        do
            ldy #0
            do
                sta (<pDestination),y
                iny
            while ne | wend
            inc <pDestination+1
            dex
        while ne | wend

        lda #low Backup | sta <pDestination
        lda #high Backup | sta <pDestination+1
        ldx #VVramHeight
        do
            lda #0
            ldy #0
            do
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pDestination | clc|adc #VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


cseg
Put1:
    sta <pSource
    lda #0 | sta <pSource+1
    asl <pSource | rol <pSource+1 ; *2
    asl <pSource | rol <pSource+1 ; *4
    asl <pSource | rol <pSource+1 ; *8
    lda <pSource | clc|adc #low Chars_ | sta <pSource
    lda <pSource+1 | adc #high Chars_ sta <pSource+1
    ldy #0
    do
        lda (<pSource),y
        sta (<pDestination),y
        iny
        cpy #CharHeight
    while ne | wend
rts


; void VPut(ptr<byte> pVram, byte c);
dseg
VPut_@Param0: public VPut_@Param0
VPut_pVram:
    defw 0
VPut_@Param1: public VPut_@Param1
VPut_c:
    defb 0
cseg
VPut_: public VPut_
    pha
        lda VPut_pVram | sta <pDestination
        lda VPut_pVram+1 | sta <pDestination+1
        
        lda VPut_c
        jsr Put1
    pla
rts


; ; void VVramToVram();
; cseg
; VVramToVram_: public VVramToVram_
;     pha
;         lda #low VVramFront_ | sta <pVVram
;         lda #high VVramFront_ | sta <pVVram+1
;         lda #low VramTop | sta <pDestination
;         lda #high VramTop | sta <pDestination+1
;         lda #low Backup | sta <pBackup
;         lda #high Backup | sta <pBackup+1

;         lda #VVramHeight | sta <yCount
;         do
;             ldy #0
;             do
;                 lda (<pVVram),y
;                 cmp (<pBackup),y
;                 if ne
;                     sta (<pBackup),y
;                     sty <xOffset
;                     jsr Put1
;                     ldy <xOffset
;                 endif
;                 lda <pDestination | clc | adc #low CharHeight | sta <pDestination
;                 lda <pDestination+1 | adc #high CharHeight | sta <pDestination+1

;                 iny
;                 cpy #VVramWidth
;             while ne | wend
;             lda <pDestination | clc | adc #low(CharHeight*(VramWidth-VVramWidth))  | sta <pDestination
;             lda <pDestination+1 | adc #high(CharHeight*(VramWidth-VVramWidth)) | sta <pDestination+1

;             lda <pVVram | clc | adc #low VVramWidth | sta <pVVram
;             lda <pVVram+1 | adc #high VVramWidth | sta <pVVram+1

;             lda <pBackup | clc | adc #low VVramWidth | sta <pBackup
;             lda <pBackup+1 | adc #high VVramWidth | sta <pBackup+1

;             dec <yCount
;         while ne | wend
;         jsr ClearRowFlags
;     pla
; rts


; ; void VVramToVramChanged();
; cseg
; VVramToVramChanged_: public VVramToVramChanged_
;     pha
;         jsr InitRow
        
;         ldx #0 
;         lda RowFlags_,x | sta <rowFlag
;         inx | stx <flagOffset
;         lda #1 | sta <maskBit

;         lda #VVramHeight | sta <yCount
;         do
;             lda <rowFlag
;             and <maskBit
;             if ne
;                 jsr VVramToVramRow
;             else
;                 lda <pDestination | clc | adc #low VramRowSize | sta <pDestination
;                 lda <pDestination+1 | adc #high VramRowSize | sta <pDestination+1
;             endif
;             jsr NextRow
;             asl <maskBit
;             if eq
;                 ldx <flagOffset
;                 lda RowFlags_,x | sta <rowFlag
;                 inx | stx <flagOffset
;                 lda #1 | sta <maskBit
;             endif
;             dec <yCount
;         while ne | wend
;         jsr ClearRowFlags
;     pla
; rts



; ; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    pha
        lda #low VVram_ | sta <pVVram
        lda #high VVram_ | sta <pVVram+1
        lda #low VramTop | sta <pDestination
        lda #high VramTop | sta <pDestination+1
        lda #low Backup | sta <pBackup
        lda #high Backup | sta <pBackup+1
        lda #VVramHeight | sta <yCount
        do
            ldy #0
            do
                lda (<pVVram),y
                cmp (<pBackup),y
                if ne
                    sta (<pBackup),y
                    sty <xOffset
                    jsr Put1
                    ldy <xOffset
                endif
                lda <pDestination | clc | adc #low CharHeight | sta <pDestination
                lda <pDestination+1 | adc #high CharHeight | sta <pDestination+1

                iny
                cpy #VVramWidth
            while ne | wend

            lda <pDestination | clc | adc #low(CharHeight*(VramWidth-VVramWidth)) | sta <pDestination
            lda <pDestination+1 | adc #high(CharHeight*(VramWidth-VVramWidth)) | sta <pDestination+1

            lda <pVVram | clc | adc #low VVramWidth | sta <pVVram
            lda <pVVram+1 | adc #high VVramWidth | sta <pVVram+1

            lda <pBackup | clc | adc #low VVramWidth | sta <pBackup
            lda <pBackup+1 | adc #high VVramWidth | sta <pBackup+1

            dec <yCount
        while ne | wend
    pla
rts
